searchData={"items":[{"type":"module","title":"Rivet.Utils.Callbacks","doc":"Contributor: Brandon Gillespie","ref":"Rivet.Utils.Callbacks.html"},{"type":"function","title":"Rivet.Utils.Callbacks.do_callback/3","doc":"```elixir\niex> do_callback(%{callbacks: nil}, nil, nil)\n:error\niex> do_callback(%{callbacks: %{mine: fn _, x -> {:ok, x} end}}, :mine, :narf)\n{:ok, :narf}\niex> do_callback(%{callbacks: %{not: fn _, x -> x end}}, :diff, :narf)\n:error\niex> do_callback(nil, :diff, :narf)\n:error\n```","ref":"Rivet.Utils.Callbacks.html#do_callback/3"},{"type":"function","title":"Rivet.Utils.Callbacks.init_callbacks/1","doc":"```elixir\niex> %{red: func} = init_callbacks([:red])\n%{red: func}\niex> init_callbacks(nil)\nnil\n```","ref":"Rivet.Utils.Callbacks.html#init_callbacks/1"},{"type":"function","title":"Rivet.Utils.Callbacks.put_callback/2","doc":"```elixir\niex> %{thisone: func} = put_callback(%{}, :thisone)\n...> is_function(func)\ntrue\n```","ref":"Rivet.Utils.Callbacks.html#put_callback/2"},{"type":"function","title":"Rivet.Utils.Callbacks.take_callbacks/2","doc":"```elixir\niex> take_callbacks(%{callbacks: %{one: 1, two: 2}}, [:two])\n%{two: 2}\niex> take_callbacks(%{callbacks: %{one: 1, two: 2}}, [])\nnil\n```","ref":"Rivet.Utils.Callbacks.html#take_callbacks/2"},{"type":"module","title":"Rivet.Utils.Cli","doc":"Common calls across mix tasks","ref":"Rivet.Utils.Cli.html"},{"type":"function","title":"Rivet.Utils.Cli.list_commands/1","doc":"","ref":"Rivet.Utils.Cli.html#list_commands/1"},{"type":"function","title":"Rivet.Utils.Cli.list_option/5","doc":"","ref":"Rivet.Utils.Cli.html#list_option/5"},{"type":"function","title":"Rivet.Utils.Cli.list_options/1","doc":"","ref":"Rivet.Utils.Cli.html#list_options/1"},{"type":"function","title":"Rivet.Utils.Cli.list_options/6","doc":"","ref":"Rivet.Utils.Cli.html#list_options/6"},{"type":"function","title":"Rivet.Utils.Cli.match_command/2","doc":"","ref":"Rivet.Utils.Cli.html#match_command/2"},{"type":"function","title":"Rivet.Utils.Cli.parse_options/2","doc":"","ref":"Rivet.Utils.Cli.html#parse_options/2"},{"type":"function","title":"Rivet.Utils.Cli.run_command/2","doc":"","ref":"Rivet.Utils.Cli.html#run_command/2"},{"type":"function","title":"Rivet.Utils.Cli.syntax/2","doc":"","ref":"Rivet.Utils.Cli.html#syntax/2"},{"type":"function","title":"Rivet.Utils.Cli.task_cmd/1","doc":"","ref":"Rivet.Utils.Cli.html#task_cmd/1"},{"type":"module","title":"Rivet.Utils.Cli.Print","doc":"Command-Line helpers for stdout/stderr I/O","ref":"Rivet.Utils.Cli.Print.html"},{"type":"function","title":"Rivet.Utils.Cli.Print.die/1","doc":"","ref":"Rivet.Utils.Cli.Print.html#die/1"},{"type":"function","title":"Rivet.Utils.Cli.Print.error/1","doc":"","ref":"Rivet.Utils.Cli.Print.html#error/1"},{"type":"function","title":"Rivet.Utils.Cli.Print.info/1","doc":"","ref":"Rivet.Utils.Cli.Print.html#info/1"},{"type":"function","title":"Rivet.Utils.Cli.Print.stderr/1","doc":"","ref":"Rivet.Utils.Cli.Print.html#stderr/1"},{"type":"function","title":"Rivet.Utils.Cli.Print.stdout/1","doc":"","ref":"Rivet.Utils.Cli.Print.html#stdout/1"},{"type":"function","title":"Rivet.Utils.Cli.Print.warn/1","doc":"","ref":"Rivet.Utils.Cli.Print.html#warn/1"},{"type":"module","title":"Rivet.Utils.Codes","doc":"Contributor: Brandon Gillespie","ref":"Rivet.Utils.Codes.html"},{"type":"function","title":"Rivet.Utils.Codes.cleaned_short_id/1","doc":"iex> cleaned_short_id(\"asdf-L0Ol\")\n\"asdf1001\"","ref":"Rivet.Utils.Codes.html#cleaned_short_id/1"},{"type":"function","title":"Rivet.Utils.Codes.generate/2","doc":"iex> {:ok, code} = generate(5, fn _ -> false end)\niex> String.length(code)\n5","ref":"Rivet.Utils.Codes.html#generate/2"},{"type":"function","title":"Rivet.Utils.Codes.get_shortest/4","doc":"","ref":"Rivet.Utils.Codes.html#get_shortest/4"},{"type":"function","title":"Rivet.Utils.Codes.stripped_uuid/0","doc":"iex> uuid = stripped_uuid()\niex> String.length(uuid)\n31","ref":"Rivet.Utils.Codes.html#stripped_uuid/0"},{"type":"function","title":"Rivet.Utils.Codes.stripped_uuid/1","doc":"","ref":"Rivet.Utils.Codes.html#stripped_uuid/1"},{"type":"module","title":"Rivet.Utils.Criteria","doc":"Criteria is used for cursor based pagination.\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Criteria.html"},{"type":"function","title":"Rivet.Utils.Criteria.limit/2","doc":"Function to apply the limit to the query (optional)","ref":"Rivet.Utils.Criteria.html#limit/2"},{"type":"function","title":"Rivet.Utils.Criteria.limit/3","doc":"","ref":"Rivet.Utils.Criteria.html#limit/3"},{"type":"function","title":"Rivet.Utils.Criteria.offset/2","doc":"Function to apply the offset to the query (optional)","ref":"Rivet.Utils.Criteria.html#offset/2"},{"type":"function","title":"Rivet.Utils.Criteria.offset/3","doc":"","ref":"Rivet.Utils.Criteria.html#offset/3"},{"type":"function","title":"Rivet.Utils.Criteria.order_by/2","doc":"Function to order the collection by attribute and direction","ref":"Rivet.Utils.Criteria.html#order_by/2"},{"type":"function","title":"Rivet.Utils.Criteria.take/2","doc":"Take out the :criteria item from the arguments\nReturns something like:\n    {:ok, %{limit: 500, offset: 1, sort: {\"taskTitle\", :asc}}}","ref":"Rivet.Utils.Criteria.html#take/2"},{"type":"module","title":"Rivet.Utils.Dig","doc":"Contributor: Brandon Gillespie","ref":"Rivet.Utils.Dig.html"},{"type":"function","title":"Rivet.Utils.Dig.dig/3","doc":"dig a value using a string index digKeys notation\nThis takes both a.b.c and a[{index}].b.c, where index\nin the second case is an indirect key/value lookup\n\niex> data = %{a: [ %{c: 1}, %{d: 2}, %{b: \"name\", c: %{d: \"meep\"}}]}\niex> dig(data, \"a[{b:name}].c.d\")\n\"meep\"\niex> dig(data, \"a[{b:name}].d.d\")\nnil\niex> dig(data, \"a[{b:bigglesworth}].c.d\")\nnil","ref":"Rivet.Utils.Dig.html#dig/3"},{"type":"function","title":"Rivet.Utils.Dig.dig_in/3","doc":"","ref":"Rivet.Utils.Dig.html#dig_in/3"},{"type":"function","title":"Rivet.Utils.Dig.dig_keys/2","doc":"[see also: frontend code base for mirror code in js]\n\nkeys must be a list of {direct: true|false, key: y}\nwhere direct=true is simply obj[key], and indirect does\na search of an array for the first key/value match\n\nNOTE: keys are always converted to atoms\n\niex> dig_keys(\"a[{b:name}].capKey.d\")\n[\n  %{ direct: true, key: :a },\n  %{ direct: false, key: [:b, \"name\"] },\n  %{ direct: true, key: :capKey },\n  %{ direct: true, key: :d }\n]\niex> dig_keys(\"a[{b:name}].capKey.d\", snake_case: true)\n[\n  %{ direct: true, key: :a },\n  %{ direct: false, key: [:b, \"name\"] },\n  %{ direct: true, key: :cap_key },\n  %{ direct: true, key: :d }\n]","ref":"Rivet.Utils.Dig.html#dig_keys/2"},{"type":"function","title":"Rivet.Utils.Dig.digx/3","doc":"dig a value using pre-parsed digKeys","ref":"Rivet.Utils.Dig.html#digx/3"},{"type":"function","title":"Rivet.Utils.Dig.dug/3","doc":"This is the inverse of dig -- put a value in place\n\niex> data = %{a: [ %{c: 1}, %{d: 2}, %{b: \"road\", c: %{d: \"meep\"}}]}\niex> dug(data, \"a[{b:road}].c.d\", \"meep meep\")\n{:ok, %{a: [ %{c: 1}, %{d: 2}, %{b: \"road\", c: %{d: \"meep meep\"}}]}}\niex> dug(data, \"a[{b:runner}].c.d\", \"meep meep\")\n{:ok, %{a: [%{c: 1}, %{d: 2}, %{b: \"road\", c: %{d: \"meep\"}}, %{b: \"runner\", c: %{d: \"meep meep\"}}]}}\niex> dug(%{i: 10}, \"i\", 5)\n{:ok, %{i: 5}}\niex> dug(%{a: [%{b: \"z\"}, %{b: \"z\"}]}, \"a[{b:z}].c\", 5)\n{:ok, %{a: [%{b: \"z\", c: 5}, %{b: \"z\"}]}}","ref":"Rivet.Utils.Dig.html#dug/3"},{"type":"function","title":"Rivet.Utils.Dig.dug!/3","doc":"","ref":"Rivet.Utils.Dig.html#dug!/3"},{"type":"function","title":"Rivet.Utils.Dig.dugx/3","doc":"","ref":"Rivet.Utils.Dig.html#dugx/3"},{"type":"module","title":"Rivet.Utils.Ecto.Atom","doc":"Custom Type to support `:atom`\ndefmodule Post do\n  use Ecto.Schema\n  schema \"posts\" do\n    field :atom_field, Ecto.Atom\n  end\nend\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Ecto.Atom.html"},{"type":"function","title":"Rivet.Utils.Ecto.Atom.cast/1","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#cast/1"},{"type":"function","title":"Rivet.Utils.Ecto.Atom.dump/1","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#dump/1"},{"type":"function","title":"Rivet.Utils.Ecto.Atom.embed_as/1","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#embed_as/1"},{"type":"function","title":"Rivet.Utils.Ecto.Atom.equal?/2","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#equal?/2"},{"type":"function","title":"Rivet.Utils.Ecto.Atom.load/1","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#load/1"},{"type":"function","title":"Rivet.Utils.Ecto.Atom.type/0","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#type/0"},{"type":"type","title":"Rivet.Utils.Ecto.Atom.t/0","doc":"","ref":"Rivet.Utils.Ecto.Atom.html#t:t/0"},{"type":"module","title":"Rivet.Utils.Ecto.AtomKeymap","doc":"Convert map keys from strings to atoms, recursively, when pulling in from the Db.\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Ecto.AtomKeymap.html"},{"type":"function","title":"Rivet.Utils.Ecto.AtomKeymap.cast/1","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#cast/1"},{"type":"function","title":"Rivet.Utils.Ecto.AtomKeymap.dump/1","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#dump/1"},{"type":"function","title":"Rivet.Utils.Ecto.AtomKeymap.embed_as/1","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#embed_as/1"},{"type":"function","title":"Rivet.Utils.Ecto.AtomKeymap.equal?/2","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#equal?/2"},{"type":"function","title":"Rivet.Utils.Ecto.AtomKeymap.load/1","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#load/1"},{"type":"function","title":"Rivet.Utils.Ecto.AtomKeymap.type/0","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#type/0"},{"type":"type","title":"Rivet.Utils.Ecto.AtomKeymap.t/0","doc":"","ref":"Rivet.Utils.Ecto.AtomKeymap.html#t:t/0"},{"type":"module","title":"Rivet.Utils.Ecto.Changeset","doc":"extensions for ecto change sets\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Ecto.Changeset.html"},{"type":"function","title":"Rivet.Utils.Ecto.Changeset.validate_clean_atom/2","doc":"If the key exists in the changeset, make sure it's a clean value","ref":"Rivet.Utils.Ecto.Changeset.html#validate_clean_atom/2"},{"type":"function","title":"Rivet.Utils.Ecto.Changeset.validate_each/3","doc":"For a value that is a list of maps, validate each element with func","ref":"Rivet.Utils.Ecto.Changeset.html#validate_each/3"},{"type":"function","title":"Rivet.Utils.Ecto.Changeset.validate_map/2","doc":"Convert keys map to atoms","ref":"Rivet.Utils.Ecto.Changeset.html#validate_map/2"},{"type":"function","title":"Rivet.Utils.Ecto.Changeset.validate_rex/4","doc":"(replacement for validate_format, which supports negation)\n\nValidates a change has the given format.\n\nThe format has to be expressed as a regular expression.","ref":"Rivet.Utils.Ecto.Changeset.html#validate_rex/4"},{"type":"function","title":"Options - Rivet.Utils.Ecto.Changeset.validate_rex/4","doc":"* `:message` - the message on failure, defaults to \"has invalid format\"\n  * `:not` - invert match for truth. default is false","ref":"Rivet.Utils.Ecto.Changeset.html#validate_rex/4-options"},{"type":"function","title":"Examples - Rivet.Utils.Ecto.Changeset.validate_rex/4","doc":"validate_rex(changeset, :email, ~r/@/)\n    validate_rex(changeset, :thing, ~r/[^a-z0-9]/, not: true)","ref":"Rivet.Utils.Ecto.Changeset.html#validate_rex/4-examples"},{"type":"function","title":"Rivet.Utils.Ecto.Changeset.validate_update/3","doc":"free-form updating, like a map","ref":"Rivet.Utils.Ecto.Changeset.html#validate_update/3"},{"type":"module","title":"Rivet.Utils.Ecto.Errors","doc":"Helper module for working with ok/error tuples\n\nContributor: Mark Erickson","ref":"Rivet.Utils.Ecto.Errors.html"},{"type":"function","title":"Rivet.Utils.Ecto.Errors.changeset_errors_to_map/1","doc":"","ref":"Rivet.Utils.Ecto.Errors.html#changeset_errors_to_map/1"},{"type":"function","title":"Rivet.Utils.Ecto.Errors.convert_error_changeset/1","doc":"","ref":"Rivet.Utils.Ecto.Errors.html#convert_error_changeset/1"},{"type":"function","title":"Rivet.Utils.Ecto.Errors.errors_to_list/1","doc":"","ref":"Rivet.Utils.Ecto.Errors.html#errors_to_list/1"},{"type":"function","title":"Rivet.Utils.Ecto.Errors.format_changeset/1","doc":"","ref":"Rivet.Utils.Ecto.Errors.html#format_changeset/1"},{"type":"function","title":"Rivet.Utils.Ecto.Errors.log_error/2","doc":"","ref":"Rivet.Utils.Ecto.Errors.html#log_error/2"},{"type":"module","title":"Rivet.Utils.Ecto.MapSet","doc":"Custom Type to support MapSet\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Ecto.MapSet.html"},{"type":"function","title":"Rivet.Utils.Ecto.MapSet.cast/1","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#cast/1"},{"type":"function","title":"Rivet.Utils.Ecto.MapSet.dump/1","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#dump/1"},{"type":"function","title":"Rivet.Utils.Ecto.MapSet.embed_as/1","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#embed_as/1"},{"type":"function","title":"Rivet.Utils.Ecto.MapSet.equal?/2","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#equal?/2"},{"type":"function","title":"Rivet.Utils.Ecto.MapSet.load/1","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#load/1"},{"type":"function","title":"Rivet.Utils.Ecto.MapSet.type/0","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#type/0"},{"type":"type","title":"Rivet.Utils.Ecto.MapSet.t/0","doc":"","ref":"Rivet.Utils.Ecto.MapSet.html#t:t/0"},{"type":"module","title":"Rivet.Utils.Ecto.Virtual","doc":"Custom Type to support any virtual data.  Always serializes to nil, so when\nincluding it as a field add virtual: true.\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Ecto.Virtual.html"},{"type":"function","title":"Rivet.Utils.Ecto.Virtual.cast/1","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#cast/1"},{"type":"function","title":"Rivet.Utils.Ecto.Virtual.dump/1","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#dump/1"},{"type":"function","title":"Rivet.Utils.Ecto.Virtual.embed_as/1","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#embed_as/1"},{"type":"function","title":"Rivet.Utils.Ecto.Virtual.equal?/2","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#equal?/2"},{"type":"function","title":"Rivet.Utils.Ecto.Virtual.load/1","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#load/1"},{"type":"function","title":"Rivet.Utils.Ecto.Virtual.type/0","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#type/0"},{"type":"type","title":"Rivet.Utils.Ecto.Virtual.t/0","doc":"","ref":"Rivet.Utils.Ecto.Virtual.html#t:t/0"},{"type":"module","title":"Rivet.Utils.Enum","doc":"Contributor: Brandon Gillespie","ref":"Rivet.Utils.Enum.html"},{"type":"function","title":"Rivet.Utils.Enum.enum_rx/2","doc":"like Enum.find_value() on a list of [{rx, fn}, ..], calling fn on the matched\nrx and returning the result.\n\niex> opts = [\n...>   {~r/^(\\d+)\\s*(m|min(s)?|minute(s)?)$/, fn match, _ -> {:min, match} end},\n...>   {~r/^(\\d+)\\s*(h|hour(s)?|hr(s)?)$/, fn match, _ -> {:hr, match} end},\n...> ]\n...> enum_rx(opts, \"30 m\")\n{:min, [\"30 m\", \"30\", \"m\"]}\niex> enum_rx(opts, \"1.5 hr\") # doesn't match because of the period\nnil","ref":"Rivet.Utils.Enum.html#enum_rx/2"},{"type":"module","title":"Rivet.Utils.Errors","doc":"Helper module for working with ok/error tuples","ref":"Rivet.Utils.Errors.html"},{"type":"function","title":"Rivet.Utils.Errors.changeset_errors_to_map/1","doc":"","ref":"Rivet.Utils.Errors.html#changeset_errors_to_map/1"},{"type":"function","title":"Rivet.Utils.Errors.convert_error_changeset/1","doc":"","ref":"Rivet.Utils.Errors.html#convert_error_changeset/1"},{"type":"function","title":"Rivet.Utils.Errors.errors_to_list/1","doc":"","ref":"Rivet.Utils.Errors.html#errors_to_list/1"},{"type":"function","title":"Rivet.Utils.Errors.format_changeset/1","doc":"","ref":"Rivet.Utils.Errors.html#format_changeset/1"},{"type":"function","title":"Rivet.Utils.Errors.log_error/2","doc":"","ref":"Rivet.Utils.Errors.html#log_error/2"},{"type":"module","title":"Rivet.Utils.Hash","doc":"Helper module for password hashes","ref":"Rivet.Utils.Hash.html"},{"type":"function","title":"Rivet.Utils.Hash.password/1","doc":"Create a new password hash","ref":"Rivet.Utils.Hash.html#password/1"},{"type":"function","title":"Rivet.Utils.Hash.verify/2","doc":"Verify a password hash","ref":"Rivet.Utils.Hash.html#verify/2"},{"type":"module","title":"Rivet.Utils.Interval","doc":"Make sure only one of a method callback is ever running.\n\nInterval and last run time are stored in state.  You can adjust interval\non the fly, but it'll kick in on second iteration after this one because\nthe next one is already queued.\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Interval.html"},{"type":"function","title":"Rivet.Utils.Interval.queue/3","doc":"","ref":"Rivet.Utils.Interval.html#queue/3"},{"type":"function","title":"Rivet.Utils.Interval.start/3","doc":"","ref":"Rivet.Utils.Interval.html#start/3"},{"type":"function","title":"Rivet.Utils.Interval.stop/2","doc":"","ref":"Rivet.Utils.Interval.html#stop/2"},{"type":"module","title":"Rivet.Utils.Interval.Tick","doc":"Similar to Interval, but tick-driven, where it has a tick frequency which is\nmore frequent than the interval frequency -- allowing for interruptions to\nthe interval and the subsequent intervals to start from there forward.\n\nSeconds used as precision, not milliseconds\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Interval.Tick.html"},{"type":"function","title":"Rivet.Utils.Interval.Tick.queue/5","doc":"","ref":"Rivet.Utils.Interval.Tick.html#queue/5"},{"type":"function","title":"Rivet.Utils.Interval.Tick.reset_next_interval/2","doc":"","ref":"Rivet.Utils.Interval.Tick.html#reset_next_interval/2"},{"type":"function","title":"Rivet.Utils.Interval.Tick.start/4","doc":"","ref":"Rivet.Utils.Interval.Tick.html#start/4"},{"type":"function","title":"Rivet.Utils.Interval.Tick.stop/2","doc":"","ref":"Rivet.Utils.Interval.Tick.html#stop/2"},{"type":"module","title":"Rivet.Utils.Interval.TickHF","doc":"High frequency interval tick - forced process state matching the interval's\ndesired structure (optimal tuple instead of dict). Runs as an independent\nGenServer process.  Send \"state data\" into GenServer.start_link(state_data)\n\nHow to use:\n\n  1. `use Utils.IntervalTickHF, [opts]` (see below for options)\n  2. define function `callback_name` which is called every frequency, with\n     an extra option of `:tick`, and every interval with the option being\n     `:tock`.  Spec:\n\n     callback_name(\n         state_data :: term(),\n         :tick | :tock,\n         last_run_time :: number()\n     ) :: {:ok, state_data :: term()}\n\nOpts include:\n\n- `callback: atom()` — REQUIRED — function to call on each interval/frequency\n- `tick: number()` — REQUIRED - integer in the time_size matching get_time.\n                     tick must be smaller than tock.  (i.e. 100 vs 1000).\n- `tock: number()` — REQUIRED - integer in the time_size matching get_time\n                     tock must be large than tick.\n- `get_time: fn()` — how time is measured; defaults to `System.system_time(:second)`\n- `millis_factor: 1000` — a multiplier to convert time from get_time into millis.\n- `handle_interval: :hf_interval_tick` — change the handle_info(:callback, ..)\n   name — largely unecessary to adjust unless the default :hf_interval_tick\n   collides with something else already being in handle_info(..)\n\nExample:\n\n  defmodule SensorReader do\n    use IntervalTickHF,\n      callback: :sample_power,\n      get_time: System.system_time(:millisecond),\n      interval: 1000,\n      frequency: 10,\n      millis_factor: 1\n\n    def sample_power({config, samples}, :tick, _) do\n      {:ok, {config, [read_value(config) | samples]}}\n    end\n\n    def sample_power({config, samples}, :tock, _) do\n      Report.Value.somehow( [read_value(config) | samples] |> normalize_samples())\n      {:ok, {config, []}}\n    end\n\n    defp read_value(config), do: ...\n    defp normalize_samples(samples), do: ...\n  end\n\nStarted with:\n\n  SensorReader.start_link({%{config_data_here}, []}, name: :the_sensor)\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.Interval.TickHF.html"},{"type":"type","title":"Rivet.Utils.Interval.TickHF.interval_state/0","doc":"","ref":"Rivet.Utils.Interval.TickHF.html#t:interval_state/0"},{"type":"type","title":"Rivet.Utils.Interval.TickHF.time_number/0","doc":"","ref":"Rivet.Utils.Interval.TickHF.html#t:time_number/0"},{"type":"module","title":"Rivet.Utils.Interval2","doc":"Make sure only one of a method callback is ever running.\n\nInterval and last run time are stored in state.  You can adjust interval\non the fly, but it'll kick in on second iteration after this one because\nthe next one is already queued.\n\nContributor: Brandon Gillespie\n\nUsage:\n\n```\nuse Interval2, tick: 1_000\n# or use Interval2, ... options\n```\n\nIn process startup:\n\n```\n  interval_start(state)\n```\n\nThen later:\n\n```\ndef interval(state) do\n  # do a thing\n  {:ok, state}\nend\n```\n\nSupported options:\n\n  tick: integer        # REQUIRED\n  error_logger: {M, f} # default: {Logger, :error} # two-arg arity\n  callback: :interval  # function name to call","ref":"Rivet.Utils.Interval2.html"},{"type":"module","title":"Rivet.Utils.JsonConfigProvider","doc":"Derived from toml-elixir/Toml.Provider https://github.com/bitwalker/toml-elixir/blob/master/lib/provider.ex\nand https://hexdocs.pm/elixir/Config.Provider.html#module-sample-config-provider\n\nThis is a runtime config provider (for 12factor apps).\n\nIt will merge json data into the config structure.\n\nIn Elixir Config:\nconfig :app, That.Module,\n  the: thing\n\nIn Elixir (Raw)\n\nApplication.get_env(:app, That.Module)\n[{ the: \"thing\" }]\n\nIn JSON, you have two special syntaxes to the keys:\n\n1. prefix 'Elixir.' on the module name if it's an elixir module:\n\n  {\"app\": {\"Elixir.That.Module\": {\"the\": \"thing\"}}}\n\n2. use \"$NAME:name\" as the key and it will pull that value at runtime\n   from the OS environment[NAME], saving it as [name] in the current\n   heirarchial location of the config file, defaulting the value to\n   whatever is set in the static variable instead.\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.JsonConfigProvider.html"},{"type":"function","title":"Rivet.Utils.JsonConfigProvider.expand_path/1","doc":"","ref":"Rivet.Utils.JsonConfigProvider.html#expand_path/1"},{"type":"function","title":"Rivet.Utils.JsonConfigProvider.init/1","doc":"","ref":"Rivet.Utils.JsonConfigProvider.html#init/1"},{"type":"function","title":"Rivet.Utils.JsonConfigProvider.keyword_pair/2","doc":"","ref":"Rivet.Utils.JsonConfigProvider.html#keyword_pair/2"},{"type":"function","title":"Rivet.Utils.JsonConfigProvider.load/2","doc":"","ref":"Rivet.Utils.JsonConfigProvider.html#load/2"},{"type":"module","title":"Rivet.Utils.LazyCache","doc":"Originally lazy_cache @ https://hex.pm/packages/lazy_cache; but with updates.","ref":"Rivet.Utils.LazyCache.html"},{"type":"module","title":"Rivet.Utils.List","doc":"Contributor: Brandon Gillespie","ref":"Rivet.Utils.List.html"},{"type":"function","title":"Rivet.Utils.List.pop/1","doc":"iex> pop([1,2,3,4,5])\n[1,2,3,4]","ref":"Rivet.Utils.List.html#pop/1"},{"type":"function","title":"Rivet.Utils.List.put_different/4","doc":"iex> put_different([], 20, 10, :last_off)\n[last_off: 10]\niex> put_different([], 10, 10, :last_off)\n[]","ref":"Rivet.Utils.List.html#put_different/4"},{"type":"function","title":"Rivet.Utils.List.setadd/3","doc":"Inefficient but simple set operations.\n\nMaintains order, returns a list, uses a \"getter\" function to pull the value\n\niex> setadd([1,2,3], 3, &(&1))\n[1,2,3]\niex> setadd([1,2,3], 4, &(&1))\n[1,2,3,4]","ref":"Rivet.Utils.List.html#setadd/3"},{"type":"function","title":"Rivet.Utils.List.setremove/3","doc":"Inefficient but simple set operations.\n\nMaintains order, returns a list, uses a \"getter\" function to pull the value\n\niex> setremove([1,2,3], 3, &(&1))\n[1,2]\niex> setremove([1,2,3], 4, &(&1))\n[1,2,3]","ref":"Rivet.Utils.List.html#setremove/3"},{"type":"function","title":"Rivet.Utils.List.trim/2","doc":"# TODO: switch to Enum.take()\n\niex> trim([1,2,3,4,5], 3)\n[1,2,3]\niex> trim([1,2,3,4], 10)\n[1,2,3,4]\niex> trim([1,2,3,4,5], 0)\n[]","ref":"Rivet.Utils.List.html#trim/2"},{"type":"module","title":"Rivet.Utils.Math","doc":"","ref":"Rivet.Utils.Math.html"},{"type":"function","title":"Rivet.Utils.Math.average/1","doc":"iex> average([])\n0.0\niex> average([30])\n30.0\niex> average([30, 32, 20, 18, 23, 26, 27])\n25.142857142857142","ref":"Rivet.Utils.Math.html#average/1"},{"type":"function","title":"Rivet.Utils.Math.deviation/2","doc":"","ref":"Rivet.Utils.Math.html#deviation/2"},{"type":"function","title":"Rivet.Utils.Math.stddev/1","doc":"iex> stddev([])\n0.0\niex> stddev([30])\n0.0\niex> stddev([2, 4, 4, 4, 5, 5, 7, 9])\n2.0","ref":"Rivet.Utils.Math.html#stddev/1"},{"type":"module","title":"Rivet.Utils.Network","doc":"Helper module for common type handling needs\n\nContributors: Brandon Gillespie, Mark Erickson, Lyle Mantooth","ref":"Rivet.Utils.Network.html"},{"type":"function","title":"Rivet.Utils.Network.lookup_address/1","doc":"```elixir\niex> lookup_address(\"nope\")\n{:error, :nxdomain}\niex> lookup_address(10)\n{:error, :einval}\niex> lookup_address('localhost')\n{:ok, {127,0,0,1}}\niex> lookup_address(\"localhost\")\n{:ok, {127,0,0,1}}\niex> lookup_address(\"127.0.0.1\")\n{:ok, {127,0,0,1}}\n```","ref":"Rivet.Utils.Network.html#lookup_address/1"},{"type":"module","title":"Rivet.Utils.Puid","doc":"Puid.generate/0 is included with the `use` statement below.  It generates 18 random characters.","ref":"Rivet.Utils.Puid.html"},{"type":"function","title":"Rivet.Utils.Puid.decode/1","doc":"Decode `puid` into representative `bits`.\n\n`puid` must a representative **puid** from this module.\n\nNOTE: `decode/1` is not supported for non-ascii character sets","ref":"Rivet.Utils.Puid.html#decode/1"},{"type":"function","title":"Rivet.Utils.Puid.encode/1","doc":"Encode `bits` into a `puid`.\n\n`bits` must contain enough bits to create a `puid`. The rest are ignored.","ref":"Rivet.Utils.Puid.html#encode/1"},{"type":"function","title":"Rivet.Utils.Puid.generate/0","doc":"Generate a `puid`","ref":"Rivet.Utils.Puid.html#generate/0"},{"type":"function","title":"Rivet.Utils.Puid.info/0","doc":"`Puid.Info` module info","ref":"Rivet.Utils.Puid.html#info/0"},{"type":"function","title":"Rivet.Utils.Puid.risk/1","doc":"Approximate **risk** in genertating `total` **puid**s","ref":"Rivet.Utils.Puid.html#risk/1"},{"type":"function","title":"Rivet.Utils.Puid.total/1","doc":"Approximate **total** possible **puid**s at a specified `risk`","ref":"Rivet.Utils.Puid.html#total/1"},{"type":"module","title":"Rivet.Utils.Puid.Bits","doc":"","ref":"Rivet.Utils.Puid.Bits.html"},{"type":"function","title":"Rivet.Utils.Puid.Bits.generate/0","doc":"","ref":"Rivet.Utils.Puid.Bits.html#generate/0"},{"type":"function","title":"Rivet.Utils.Puid.Bits.reset/0","doc":"","ref":"Rivet.Utils.Puid.Bits.html#reset/0"},{"type":"module","title":"Rivet.Utils.Puid.Decoder","doc":"","ref":"Rivet.Utils.Puid.Decoder.html"},{"type":"function","title":"Rivet.Utils.Puid.Decoder.decode/1","doc":"","ref":"Rivet.Utils.Puid.Decoder.html#decode/1"},{"type":"function","title":"Rivet.Utils.Puid.Decoder.decode_pair/1","doc":"","ref":"Rivet.Utils.Puid.Decoder.html#decode_pair/1"},{"type":"function","title":"Rivet.Utils.Puid.Decoder.decode_single/1","doc":"","ref":"Rivet.Utils.Puid.Decoder.html#decode_single/1"},{"type":"module","title":"Rivet.Utils.Puid.Encoder","doc":"","ref":"Rivet.Utils.Puid.Encoder.html"},{"type":"function","title":"Rivet.Utils.Puid.Encoder.encode/1","doc":"","ref":"Rivet.Utils.Puid.Encoder.html#encode/1"},{"type":"module","title":"Rivet.Utils.RandChars","doc":"","ref":"Rivet.Utils.RandChars.html"},{"type":"function","title":"Rivet.Utils.RandChars.random/0","doc":"random/0 generates a 72-character random string.","ref":"Rivet.Utils.RandChars.html#random/0"},{"type":"module","title":"Rivet.Utils.Redact","doc":"redact text based on common patterns for insecure data\n\nContributor: Unknown","ref":"Rivet.Utils.Redact.html"},{"type":"function","title":"Rivet.Utils.Redact.obfuscate/1","doc":"iex> obfuscate(\"\")\n\"\"\niex> obfuscate(\"h\")\n\"h\"\niex> obfuscate(\"he\")\n\"h*\"\niex> obfuscate(\"hello\")\n\"h***o\"\niex> obfuscate(\"hello world\")\n\"h*********d\"","ref":"Rivet.Utils.Redact.html#obfuscate/1"},{"type":"function","title":"Rivet.Utils.Redact.redact_string/1","doc":"iex> redact_string(\"this password:Frieb398f3e is nice\")\n\"this password:*** is nice\"\niex> redact_string(\"this password:\\\"Frieb398f3e\\\" is nice\")\n\"this password:*** is nice\"\niex> redact_string(\"this password=Frieb398f3e is nice\")\n\"this password=*** is nice\"\niex> redact_string(\"this password=\\\"Frieb398f3e\\\" is nice\")\n\"this password=*** is nice\"\niex> redact_string(\"this password: Frieb398f3e is nice\")\n\"this password:*** is nice\"\niex> redact_string(\"this password: \\\"Frieb398f3e\\\" is nice\")\n\"this password:*** is nice\"\niex> redact_string(\"this password = Frieb398f3e is nice\")\n\"this password=*** is nice\"\niex> redact_string(\"this password = \\\"Frieb398f3e\\\" is nice\")\n\"this password=*** is nice\"\niex> redact_string(\"this key: <<10, 20, 30>> is nice\")\n\"this key:*** is nice\"\niex> redact_string(\"curve_publickey: <<142, 243, 120, 122, ...>>, curve_secretkey: <<97, 10, 116, 57, 7, 84, 65, 254, 83, 106>>,\")\n\"curve_publickey:***, curve_secretkey:***,\"","ref":"Rivet.Utils.Redact.html#redact_string/1"},{"type":"module","title":"Rivet.Utils.Time","doc":"Contributor: Brandon Gillespie","ref":"Rivet.Utils.Time.html"},{"type":"function","title":"Rivet.Utils.Time.ago/2","doc":"Provide the time in a \"x hours/mins/seconds/etc\" ago type format.\nOptions. Time can be provided as posix epoch (preferred), or DateTime,\nor NaiveDateTime.\n\n- `since: time` — compare vs this time instead of \"now\"\n- `format: :long | :short(default) | :abbrev`\n    - long format uses no shortened words (minute, second)\n    - short (default) uses 'min' and 'sec' instead of the longer forms\n    - abbrev uses one and two character abbreviations\n- `space: \" \"` (default)\n\nExamples:\n\niex> (epoch_time() - 60) |> ago()\n\"1 min\"\n\niex> (epoch_time() - 11000) |> ago()\n\"3 hours\"\n\niex> DateTime.from_unix!(epoch_time() - 86400) |> ago(format: :abbrev, space: \"\")\n\"1d\"\n\niex> ago(epoch_time() - 300, format: :long)\n\"5 minutes\"\n\niex> t_start = epoch_time() - 900\niex> t_end = epoch_time() - 300\niex> ago(t_start, since: t_end, format: :long)\n\"10 minutes\"\niex> ago(t_end, since: t_start, format: :long)\n\"10 minutes\"","ref":"Rivet.Utils.Time.html#ago/2"},{"type":"function","title":"Rivet.Utils.Time.as_epoch/1","doc":"Because posix epoch time is just easier to work with once you understand how\nit works.","ref":"Rivet.Utils.Time.html#as_epoch/1"},{"type":"function","title":"Rivet.Utils.Time.epoch_time/1","doc":"this wraps the complexities brought on by Erlang being fancy with time,\nand gives us a conventional posix/epoch time value.  The time value to\nreturn is specified by the first argument, as an atom, and is a required\nargument (to remove ambiguity), from the set:\n\n  :second, :millisecond, :microsecond or :nanosecond\n\nIt also uses their best value for 'monotonic' time so the clock will\nnot go backwards.\n\nFor the full story see:\n  https://hexdocs.pm/elixir/System.html\n  http://erlang.org/doc/apps/erts/time_correction.html","ref":"Rivet.Utils.Time.html#epoch_time/1"},{"type":"function","title":"Rivet.Utils.Time.ifloor/1","doc":"","ref":"Rivet.Utils.Time.html#ifloor/1"},{"type":"function","title":"Rivet.Utils.Time.iso_time_range/1","doc":"","ref":"Rivet.Utils.Time.html#iso_time_range/1"},{"type":"function","title":"Rivet.Utils.Time.iso_time_range/2","doc":"","ref":"Rivet.Utils.Time.html#iso_time_range/2"},{"type":"function","title":"Rivet.Utils.Time.now/0","doc":"","ref":"Rivet.Utils.Time.html#now/0"},{"type":"function","title":"Rivet.Utils.Time.now/1","doc":"","ref":"Rivet.Utils.Time.html#now/1"},{"type":"function","title":"Rivet.Utils.Time.start_datetime_of_posix_interval/4","doc":"start_datetime_of_posix_interval/4.\n\nSuppose you have a DateTime that is 30 seconds past the beginning of a given minute. If the interval is 60_000\nmilliseconds (1 min.), then the beginning of the next posix interval is 30 seconds later- this returns that datetime.","ref":"Rivet.Utils.Time.html#start_datetime_of_posix_interval/4"},{"type":"function","title":"Rivet.Utils.Time.time_duration/1","doc":"","ref":"Rivet.Utils.Time.html#time_duration/1"},{"type":"function","title":"Rivet.Utils.Time.to_minutes/2","doc":"","ref":"Rivet.Utils.Time.html#to_minutes/2"},{"type":"function","title":"Rivet.Utils.Time.utc_hours_since_midnight_sunday/0","doc":"utc_hours_since_midnight_sunday/0.\n\nThere are 168 hours in a week, we zero-index them from 12:00:00 a.m. UTC Sunday.","ref":"Rivet.Utils.Time.html#utc_hours_since_midnight_sunday/0"},{"type":"function","title":"Rivet.Utils.Time.utc_offset/1","doc":"","ref":"Rivet.Utils.Time.html#utc_offset/1"},{"type":"module","title":"Rivet.Utils.UniformLogFormat","doc":"Provide custom log formatting that is friendly for both reading and indexing\neither via ELK or splunk.\n\nhttps://surfingthe.cloud/uniform-log-format/\n\nContributor: Brandon Gillespie","ref":"Rivet.Utils.UniformLogFormat.html"},{"type":"function","title":"Rivet.Utils.UniformLogFormat.data2txt/1","doc":"","ref":"Rivet.Utils.UniformLogFormat.html#data2txt/1"},{"type":"function","title":"Rivet.Utils.UniformLogFormat.filter_meta/3","doc":"","ref":"Rivet.Utils.UniformLogFormat.html#filter_meta/3"},{"type":"function","title":"Rivet.Utils.UniformLogFormat.format/4","doc":"","ref":"Rivet.Utils.UniformLogFormat.html#format/4"},{"type":"function","title":"Rivet.Utils.UniformLogFormat.format_meta/2","doc":"iex> format_meta([a: 1, line: 10, b: 2, level: :info, c: 3], :info) |> IO.iodata_to_binary()\n\" a=1 b=2 c=3\"\niex> format_meta([key: 10, line: 20, level: :debug], :info) |> IO.iodata_to_binary()\n\" key=10 level=debug\"\niex> format_meta([module: Module.Thing], :debug) |> IO.iodata_to_binary()\n\" module=Module.Thing\"\niex> format_meta([module: Module.Thing], :info)\n[]\niex> format_meta([key: 42, module: :phoenix], :info) |> IO.iodata_to_binary()\n\" key=42\"\niex> format_meta([key: 42, file: \"narf\"], :info) |> IO.iodata_to_binary()\n\" key=42\"\niex> format_meta([key: 42, file: \"narf\"], :debug)\n[\n [' ', \"key\", 61, \"42\"],\n [' ', \"file\", 61, \"narf\"]\n]","ref":"Rivet.Utils.UniformLogFormat.html#format_meta/2"},{"type":"function","title":"Rivet.Utils.UniformLogFormat.format_msg/2","doc":"iex> format_msg([], %{})\n[]\n\nDicts end up being alphabetic keys due to their nature:\n\niex> format_msg(%{key: 10, other: 20, a: 5}, %{}) |> IO.iodata_to_binary()\n\" other=20 a=5 key=10\"\n\nKeyword lists will stay in-order:\n\niex> format_msg([key: 10, a: 5, other: 20], %{}) |> IO.iodata_to_binary()\n\" key=10 a=5 other=20\"\niex> format_msg('a charlist', %{})\n[' ', \"a charlist\"]\niex> format_msg(\"a string\", %{})\n[' ', \"a string\"]\niex> format_msg({:tuple}, %{})\n[' ', \"data=\", \"{:tuple}\"]\n\n#iex> format_msg({:tuple}, %{report_cb: fn x -> inspect(x) end})\n#[' ', \"{:tuple}\"]","ref":"Rivet.Utils.UniformLogFormat.html#format_msg/2"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}